GNU bug report logs - #51390
29.0.50; repeat-mode: Fails to repeat keys in global-map(?)

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Visuwesh <visuwesh@HIDDEN>; Done: Juri Linkov <juri@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
bug marked as fixed in version 28.0.60, send any further explanations to 51390 <at> debbugs.gnu.org and Visuwesh <visuwesh@HIDDEN> Request was from Juri Linkov <juri@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 30 Nov 2021 19:09:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 30 14:09:48 2021
Received: from localhost ([127.0.0.1]:42527 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ms8Vf-0007nl-TR
	for submit <at> debbugs.gnu.org; Tue, 30 Nov 2021 14:09:48 -0500
Received: from relay7-d.mail.gandi.net ([217.70.183.200]:57549)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>)
 id 1ms8Vd-0007nN-Bl; Tue, 30 Nov 2021 14:09:45 -0500
Received: (Authenticated sender: juri@HIDDEN)
 by relay7-d.mail.gandi.net (Postfix) with ESMTPSA id 9D63320005;
 Tue, 30 Nov 2021 19:09:37 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Visuwesh <visuwesh@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
Organization: LINKOV.NET
References: <MmsHxhi--3-2@HIDDEN> <86sfvpxmhn.fsf@HIDDEN>
 <MpK7CpY--3-2@HIDDEN> <867dcwwtyr.fsf@HIDDEN>
 <MpL8_rl--3-2@HIDDEN>
Date: Tue, 30 Nov 2021 21:09:28 +0200
In-Reply-To: <MpL8_rl--3-2@HIDDEN> (visuwesh@HIDDEN's message of
 "Thu, 25 Nov 2021 09:11:36 +0100 (CET)")
Message-ID: <86k0gpbh1j.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

close 51390 28.0.60
thanks

>> This feature of checking the last key could be enabled per every keymap
>> using symbol properties.  Then you can disable it for one keymap,
>> while keeping enabled for all remaining keymaps.
>
> That indeed sounds like a good solution to the problem. Thanks!

This is fixed now, so your original case is supported,
as well as more cases reported in e.g.
https://lists.gnu.org/archive/html/emacs-devel/2021-04/msg00083.html
https://lists.gnu.org/archive/html/emacs-devel/2021-08/msg00962.html

The behavior can be customized by the new user option 'repeat-check-key'.
Also a command can have a symbol property with the same name
and two values: 't' checks the key when the variable is nil,
and 'no' doesn't check the key when the variable is t.

A special property 'no' is necessary instead of using 'nil',
because 'get' can't distinguish when the property has the
value 'nil' and when there is no property set on the symbol.
Also there is no function to delete a property from a plist,
so every package invents own wheel, e.g. map--plist-delete.
org-plist-delete-all, svg--plist-delete...




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 25 Nov 2021 08:11:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 25 03:11:44 2021
Received: from localhost ([127.0.0.1]:55668 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mq9r5-0003PN-Nq
	for submit <at> debbugs.gnu.org; Thu, 25 Nov 2021 03:11:43 -0500
Received: from w1.tutanota.de ([81.3.6.162]:43206)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <visuwesh@HIDDEN>) id 1mq9r4-0003PA-CA
 for 51390 <at> debbugs.gnu.org; Thu, 25 Nov 2021 03:11:42 -0500
Received: from w3.tutanota.de (unknown [192.168.1.164])
 by w1.tutanota.de (Postfix) with ESMTP id 66462FBF803;
 Thu, 25 Nov 2021 08:11:36 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1637827896; 
 s=s1; d=tutanota.com;
 h=From:From:To:To:Subject:Subject:Content-Description:Content-ID:Content-Type:Content-Type:Content-Transfer-Encoding:Content-Transfer-Encoding:Cc:Cc:Date:Date:In-Reply-To:In-Reply-To:MIME-Version:MIME-Version:Message-ID:Message-ID:Reply-To:References:References:Sender;
 bh=x4liwaRCpo95ju/FQbC/2SJk+QZlnp/TdNI9uxMX0+E=;
 b=A0L4lOFndAokYqMYQeGjjUCHqT0Va9+7usgbDsAYqOdDMOjDj7nnUSidfnmf8iyz
 Hh72UzV3Gpsf7HE2nQiISinYMI0D9D6pnwk+w2VgrKGkKLDHD3LPjxb210qZYWPXkce
 2d0gTVQCSKukxBwzB6hjj/tmM2dIaPELZaRXstBjW5KnfttlqyWJ1BOH8v5SklwJ5oM
 7S3WDd23RoiFFjBf/Vv2UpKGuotQ3Xm85QCgpyyDICOgJP2s48zmeuj1Ad9XJiVkyzN
 9NVDQtlUHn2i4/qLK2NwCetAZYcNa2CHRYIhC4niFeCtq9Z77cY4OPPFiyPbVxLGT54
 9OyNT3ZhYA==
Date: Thu, 25 Nov 2021 09:11:36 +0100 (CET)
From: Visuwesh <visuwesh@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Message-ID: <MpL8_rl--3-2@HIDDEN>
In-Reply-To: <867dcwwtyr.fsf@HIDDEN>
References: <MmsHxhi--3-2@HIDDEN> <86sfvpxmhn.fsf@HIDDEN>
 <MpK7CpY--3-2@HIDDEN> <867dcwwtyr.fsf@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

25 Nov 2021, 13:24 by juri@HIDDEN:

Hi Juri,
>>> This means that by default this behavior should be disabled.
>>> But maybe a new variable should allow to skip this check:
>>>
>>
>> Yes,=C2=A0 you are right, it is disruptive.=C2=A0 Having tried the repea=
t-map I
>> had in the OP for a while now, it is biting me in the back in the most
>> unexpected times.=C2=A0 Maybe this is better left unimplemented?
>>
>
> This feature of checking the last key could be enabled per every keymap
> using symbol properties.  Then you can disable it for one keymap,
> while keeping enabled for all remaining keymaps.
>

That indeed sounds like a good solution to the problem.=C2=A0 Thanks!




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 25 Nov 2021 08:00:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 25 03:00:37 2021
Received: from localhost ([127.0.0.1]:55659 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mq9gL-00039c-CJ
	for submit <at> debbugs.gnu.org; Thu, 25 Nov 2021 03:00:37 -0500
Received: from relay6-d.mail.gandi.net ([217.70.183.198]:33487)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1mq9gH-00039I-7m
 for 51390 <at> debbugs.gnu.org; Thu, 25 Nov 2021 03:00:35 -0500
Received: (Authenticated sender: juri@HIDDEN)
 by relay6-d.mail.gandi.net (Postfix) with ESMTPSA id E1866C0005;
 Thu, 25 Nov 2021 08:00:26 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Visuwesh <visuwesh@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
Organization: LINKOV.NET
References: <MmsHxhi--3-2@HIDDEN> <86sfvpxmhn.fsf@HIDDEN>
 <MpK7CpY--3-2@HIDDEN>
Date: Thu, 25 Nov 2021 09:54:52 +0200
In-Reply-To: <MpK7CpY--3-2@HIDDEN> (visuwesh@HIDDEN's message of
 "Thu, 25 Nov 2021 04:32:26 +0100 (CET)")
Message-ID: <867dcwwtyr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> This means that by default this behavior should be disabled.
>> But maybe a new variable should allow to skip this check:
>
> Yes, you are right, it is disruptive. Having tried the repeat-map I
> had in the OP for a while now, it is biting me in the back in the most
> unexpected times. Maybe this is better left unimplemented?

This feature of checking the last key could be enabled per every keymap
using symbol properties.  Then you can disable it for one keymap,
while keeping enabled for all remaining keymaps.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 25 Nov 2021 03:32:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 24 22:32:36 2021
Received: from localhost ([127.0.0.1]:55439 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mq5Uy-0004mk-0Z
	for submit <at> debbugs.gnu.org; Wed, 24 Nov 2021 22:32:36 -0500
Received: from w1.tutanota.de ([81.3.6.162]:42088)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <visuwesh@HIDDEN>) id 1mq5Uv-0004mU-1B
 for 51390 <at> debbugs.gnu.org; Wed, 24 Nov 2021 22:32:34 -0500
Received: from w3.tutanota.de (unknown [192.168.1.164])
 by w1.tutanota.de (Postfix) with ESMTP id C9E3AFA032A;
 Thu, 25 Nov 2021 03:32:26 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1637811146; 
 s=s1; d=tutanota.com;
 h=From:From:To:To:Subject:Subject:Content-Description:Content-ID:Content-Type:Content-Type:Content-Transfer-Encoding:Content-Transfer-Encoding:Cc:Cc:Date:Date:In-Reply-To:In-Reply-To:MIME-Version:MIME-Version:Message-ID:Message-ID:Reply-To:References:References:Sender;
 bh=I8Rs/R4v3jUs374ts3f+4nPa2pLz9NK0KJql1qAd+4I=;
 b=xJPjRwzb3HsgSOnR9MAk+FuiHKPiJj84clnqYcYjC9iF0TTCbFYDfOQxcLKDN2Zk
 JFRzHPhueoHFn8KjM3rUQw1ODDPGV0HblddTJkKx237m401Nl9d6GIJtQ8qNxi5Fp7u
 El5TZXtiho7tdoGcy9jYKrX3bavMVkHBBoWPkDsNRbT+/HfWZGm/f9iCUv4M/5S8xXL
 0i1bKdGoNE51o9AyF+hO2NXbPw7K74Ju/NmO6jEdULiVIml2ZrjjEhy2qrgk85tkJj0
 a6LUncUPIksP+bgg4PKsRianLFlkQAletHro3TDjG7RFaRTo7jXhhL+jrhLIBwFmR9R
 cLHRVXpeJQ==
Date: Thu, 25 Nov 2021 04:32:26 +0100 (CET)
From: Visuwesh <visuwesh@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Message-ID: <MpK7CpY--3-2@HIDDEN>
In-Reply-To: <86sfvpxmhn.fsf@HIDDEN>
References: <MmsHxhi--3-2@HIDDEN> <86sfvpxmhn.fsf@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

22 Nov 2021, 02:19 by juri@HIDDEN:

Hi Juri,

> I tried to implement what you asked to do, but got horrible results
> caused too much damage. Here is the lossage explaining the problem:
>
> C-<tab> ;; tab-next
> o ;; tab-next
> n ;; gnus-group-next-unread-group
>
> i.e. I typed C-<tab> to switch to the next tab with the text buffer
> where I started to type text that begins with the letters "on..."
>
> But instead of inserting letters to the buffer, the letter "o"
> switched to the second next tab. This tab contained the Gnus buffer
> where typing the second letter "n" called the bound command
> gnus-group-next-unread-group, and I lost all unread messages.
>
> But I never had such a problem when the repeating sequence was
> activated only by 'C-x t o ... o o ...' instead of 'C-<tab> o o o ...'
> because 'C-<tab>' is a single key, there is no need to activate
> other keys doing the same.
>
> This means that by default this behavior should be disabled.
> But maybe a new variable should allow to skip this check:

Yes,=C2=A0 you are right, it is disruptive.=C2=A0 Having tried the repeat-m=
ap I
had in the OP for a while now, it is biting me in the back in the most
unexpected times.=C2=A0 Maybe this is better left unimplemented?






Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 22 Nov 2021 03:45:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 21 22:45:52 2021
Received: from localhost ([127.0.0.1]:46551 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mp0H9-0002di-SB
	for submit <at> debbugs.gnu.org; Sun, 21 Nov 2021 22:45:52 -0500
Received: from w1.tutanota.de ([81.3.6.162]:55872)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <visuwesh@HIDDEN>) id 1mp0H8-0002dW-QP
 for 51390 <at> debbugs.gnu.org; Sun, 21 Nov 2021 22:45:51 -0500
Received: from w3.tutanota.de (unknown [192.168.1.164])
 by w1.tutanota.de (Postfix) with ESMTP id 5F755FBF568;
 Mon, 22 Nov 2021 03:45:45 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1637552745; 
 s=s1; d=tutanota.com;
 h=From:From:To:To:Subject:Subject:Content-Description:Content-ID:Content-Type:Content-Type:Content-Transfer-Encoding:Content-Transfer-Encoding:Cc:Cc:Date:Date:In-Reply-To:In-Reply-To:MIME-Version:MIME-Version:Message-ID:Message-ID:Reply-To:References:References:Sender;
 bh=VC0+d3xR+U6E1N89FX74BL2WAkzfUepxgi3iAkq33T8=;
 b=bSIluhangJVJJVhi+JqU3ytuHVN3m7shoGdonuDVigKpot+WFRkI62LzuXO8tnqO
 r+8sPP/aBgXzYmPLKDQTqlkhJBpZxeY2cXpPa8dV425vuEGp+67YzHj7o6I8DTNPIlQ
 8SD6KQg2nqyhwN8lX6GTBRlZyYI41jCBWS7lPrJUGCQB/tGa+Tl85mkjpf2w6BrsTb+
 2Of43AGLfPjWkcLtOlJB0xm3766Bz1bg8GBCteR4KyMgUs4fFv/cnF4M+XfJN9hjpbS
 +GToIWixtExedXzwGS9OH0AJCgWYrNX3oKW+L1rOxcVtZYfTEkOj919ip3/voe1UMe3
 OTkyjPVbuw==
Date: Mon, 22 Nov 2021 04:45:45 +0100 (CET)
From: Visuwesh <visuwesh@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Message-ID: <Mp4jyRh--3-2@HIDDEN>
In-Reply-To: <Mp4jhv0--3-2@HIDDEN>
References: <MmsHxhi--3-2@HIDDEN> <86sfvpxmhn.fsf@HIDDEN>
 <Mp4jhv0--3-2@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


22 Nov 2021, 09:14 by visuwesh@HIDDEN:

> 22 Nov 2021, 02:19 by juri@HIDDEN:
>
>>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (defvar teest
>>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (let ((map (make=
-sparse-keymap)))
>>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (def=
ine-key map "n" #'next-line)
>>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (def=
ine-key map "p" #'previous-line)
>>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 map)=
)
>>>
>>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (put 'next-line 'repeat-map =
'teest)
>>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (put 'previous-line 'repeat-=
map 'teest)
>>>
>> >...
>>
>>> 4. Type C-n.=C2=A0 Notice that it does not trigger the repeat map.
>>>
>>
>> I tried to implement what you asked to do, but got horrible results
>> caused too much damage.  Here is the lossage explaining the problem:
>>
>> C-<tab>           ;; tab-next
>> o                 ;; tab-next
>> n                 ;; gnus-group-next-unread-group
>>
>> i.e. I typed C-<tab> to switch to the next tab with the text buffer
>> where I started to type text that begins with the letters "on..."
>>
>> But instead of inserting letters to the buffer, the letter "o"
>> switched to the second next tab.  This tab contained the Gnus buffer
>> where typing the second letter "n" called the bound command
>> gnus-group-next-unread-group, and I lost all unread messages.
>>
>> But I never had such a problem when the repeating sequence was
>> activated only by 'C-x t o ... o o ...' instead of 'C-<tab> o o o ...'
>> because 'C-<tab>' is a single key, there is no need to activate
>> other keys doing the same.
>>
>> This means that by default this behavior should be disabled.
>> But maybe a new variable should allow to skip this check:
>>
>
> Hi Juri,
> I am currently in the middle of exams, I will try out the patch in a coup=
le
>
in a couple of days, that is.

I pressed the send key too quickly.=C2=A0 Sorry for the noise.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 22 Nov 2021 03:44:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 21 22:44:45 2021
Received: from localhost ([127.0.0.1]:46540 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mp0G5-0002b3-38
	for submit <at> debbugs.gnu.org; Sun, 21 Nov 2021 22:44:45 -0500
Received: from w1.tutanota.de ([81.3.6.162]:55584)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <visuwesh@HIDDEN>) id 1mp0G3-0002ao-ID
 for 51390 <at> debbugs.gnu.org; Sun, 21 Nov 2021 22:44:44 -0500
Received: from w3.tutanota.de (unknown [192.168.1.164])
 by w1.tutanota.de (Postfix) with ESMTP id 6CCF8FBF816;
 Mon, 22 Nov 2021 03:44:37 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1637552677; 
 s=s1; d=tutanota.com;
 h=From:From:To:To:Subject:Subject:Content-Description:Content-ID:Content-Type:Content-Type:Content-Transfer-Encoding:Content-Transfer-Encoding:Cc:Cc:Date:Date:In-Reply-To:In-Reply-To:MIME-Version:MIME-Version:Message-ID:Message-ID:Reply-To:References:References:Sender;
 bh=5HRd+3YXKULHXofGCbSejokwOMGE58mUa5aIUBqM5+s=;
 b=0s1P38axSdyo2Ppp/GDJyZS660kS6lwWi3OzKcZIbF74gVYNxztjywJylyf5jPBq
 Ccf5mm1XlOGAD1r2f7nV652lnvM+zfI78NJWzE6+7DK91ywp7L/nfUbF8rg/wKr/D2Q
 JjaaMTPfW+DczAi5P/UQDwx+vFCoFCVyE+PYxsEjYHnGouBGYycT458asIP2eyZ4TZO
 Ukb/aOdmXYlM5935cYK09vxhZ94lO8B8iNfB0t1+0n8Ndv31mGlzufy711VnsnNYan7
 BfRx5cyb33dfecE8QWF1lTXSheOkiv/pXmuwuh4NVJp5qHxzqrS9qoNT1B9zYLqkC+a
 iYMDB6xVSQ==
Date: Mon, 22 Nov 2021 04:44:37 +0100 (CET)
From: Visuwesh <visuwesh@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Message-ID: <Mp4jhv0--3-2@HIDDEN>
In-Reply-To: <86sfvpxmhn.fsf@HIDDEN>
References: <MmsHxhi--3-2@HIDDEN> <86sfvpxmhn.fsf@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

22 Nov 2021, 02:19 by juri@HIDDEN:

>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (defvar teest
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (let ((map (make-=
sparse-keymap)))
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (defi=
ne-key map "n" #'next-line)
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (defi=
ne-key map "p" #'previous-line)
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 map))
>>
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (put 'next-line 'repeat-map '=
teest)
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (put 'previous-line 'repeat-m=
ap 'teest)
>>
> >...
>
>> 4. Type C-n.=C2=A0 Notice that it does not trigger the repeat map.
>>
>
> I tried to implement what you asked to do, but got horrible results
> caused too much damage.  Here is the lossage explaining the problem:
>
>  C-<tab>           ;; tab-next
>  o                 ;; tab-next
>  n                 ;; gnus-group-next-unread-group
>
> i.e. I typed C-<tab> to switch to the next tab with the text buffer
> where I started to type text that begins with the letters "on..."
>
> But instead of inserting letters to the buffer, the letter "o"
> switched to the second next tab.  This tab contained the Gnus buffer
> where typing the second letter "n" called the bound command
> gnus-group-next-unread-group, and I lost all unread messages.
>
> But I never had such a problem when the repeating sequence was
> activated only by 'C-x t o ... o o ...' instead of 'C-<tab> o o o ...'
> because 'C-<tab>' is a single key, there is no need to activate
> other keys doing the same.
>
> This means that by default this behavior should be disabled.
> But maybe a new variable should allow to skip this check:
>

Hi Juri,

I am currently in the middle of exams, I will try out the patch in a couple




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 21 Nov 2021 20:53:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 21 15:53:51 2021
Received: from localhost ([127.0.0.1]:46181 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1motqR-0006sS-C3
	for submit <at> debbugs.gnu.org; Sun, 21 Nov 2021 15:53:51 -0500
Received: from relay6-d.mail.gandi.net ([217.70.183.198]:55759)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1motqQ-0006sE-1M
 for 51390 <at> debbugs.gnu.org; Sun, 21 Nov 2021 15:53:50 -0500
Received: (Authenticated sender: juri@HIDDEN)
 by relay6-d.mail.gandi.net (Postfix) with ESMTPSA id 67E64C0007;
 Sun, 21 Nov 2021 20:53:41 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Visuwesh <visuwesh@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
Organization: LINKOV.NET
References: <MmsHxhi--3-2@HIDDEN>
Date: Sun, 21 Nov 2021 22:49:40 +0200
In-Reply-To: <MmsHxhi--3-2@HIDDEN> (Visuwesh via's message of "Mon, 25
 Oct 2021 18:32:33 +0200 (CEST)")
Message-ID: <86sfvpxmhn.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit

>  (defvar teest
>  (let ((map (make-sparse-keymap)))
>  (define-key map "n" #'next-line)
>  (define-key map "p" #'previous-line)
>  map))
>
>  (put 'next-line 'repeat-map 'teest)
>  (put 'previous-line 'repeat-map 'teest)
>...
> 4. Type C-n. Notice that it does not trigger the repeat map.

I tried to implement what you asked to do, but got horrible results
caused too much damage.  Here is the lossage explaining the problem:

 C-<tab>           ;; tab-next
 o                 ;; tab-next
 n                 ;; gnus-group-next-unread-group

i.e. I typed C-<tab> to switch to the next tab with the text buffer
where I started to type text that begins with the letters "on..."

But instead of inserting letters to the buffer, the letter "o"
switched to the second next tab.  This tab contained the Gnus buffer
where typing the second letter "n" called the bound command
gnus-group-next-unread-group, and I lost all unread messages.

But I never had such a problem when the repeating sequence was
activated only by 'C-x t o ... o o ...' instead of 'C-<tab> o o o ...'
because 'C-<tab>' is a single key, there is no need to activate
other keys doing the same.

This means that by default this behavior should be disabled.
But maybe a new variable should allow to skip this check:


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline; filename=repeat-foreign-key.patch

diff --git a/lisp/repeat.el b/lisp/repeat.el
index 4dcd353e34..03e5b032fe 100644
--- a/lisp/repeat.el
+++ b/lisp/repeat.el
@@ -360,6 +360,12 @@ repeat-keep-prefix
   :group 'convenience
   :version "28.1")
 
+(defcustom repeat-foreign-key nil
+  "Whether to check if the last key exists in the repeat map."
+  :type 'boolean
+  :group 'convenience
+  :version "28.1")
+
 (defcustom repeat-echo-function #'repeat-echo-message
   "Function to display a hint about available keys.
 Function is called after every repeatable command with one argument:
@@ -428,7 +434,8 @@ repeat-post-hook
                        (eq current-minibuffer-command (cdr repeat--prev-mb)))
                    ;; Exit when the last char is not among repeatable keys,
                    ;; so e.g. `C-x u u' repeats undo, whereas `C-/ u' doesn't.
-                   (or (lookup-key map (this-command-keys-vector))
+                   (or repeat-foreign-key
+                       (lookup-key map (vector last-nonmenu-event))
                        prefix-arg))
 
               ;; Messaging

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 21 Nov 2021 02:22:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 20 21:22:09 2021
Received: from localhost ([127.0.0.1]:43879 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mocUb-0004uw-2L
	for submit <at> debbugs.gnu.org; Sat, 20 Nov 2021 21:22:09 -0500
Received: from w1.tutanota.de ([81.3.6.162]:44648)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <visuwesh@HIDDEN>) id 1mocUW-0004uM-Mr
 for 51390 <at> debbugs.gnu.org; Sat, 20 Nov 2021 21:22:07 -0500
Received: from w3.tutanota.de (unknown [192.168.1.164])
 by w1.tutanota.de (Postfix) with ESMTP id 9F628FA01B2;
 Sun, 21 Nov 2021 02:21:58 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1637461318; 
 s=s1; d=tutanota.com;
 h=From:From:To:To:Subject:Subject:Content-Description:Content-ID:Content-Type:Content-Type:Content-Transfer-Encoding:Content-Transfer-Encoding:Cc:Cc:Date:Date:In-Reply-To:In-Reply-To:MIME-Version:MIME-Version:Message-ID:Message-ID:Reply-To:References:References:Sender;
 bh=9FodOEdMCegTQlFI4xd5z2UHaPMy/IB5yT2sknNUd64=;
 b=fJ89FAV2L4vdSylYFL8pNZgSCMjlrqTSU1XGHcOrW7fDqUgY2kb4gQR3oiogt3ab
 9to6wzL1nZjXc1cdiOlzGzTKNEYnc0BFZD9ffxstZ0LF8ZzfBm8+ozTTJQaYfWQod8m
 4xtwU/gDgcZ6z+QO17RkW4Ge1+ue2PN1FkKC8qdCU54GbqJVZPO2IveuZrh+XSqrBUE
 ISaNICnA6bxh5cJZujT3+GSTr6Sflz92DHMkJhc/1/8LJqyMtFeVumGxL1G1NPBqP+g
 gnmWaAnZhrNiL065TuuaVCP8dLM+suH1Z96x0Tl53Iy4WdR5Nyr7tVoaNw2BZpnuSIP
 TyksbbRMrw==
Date: Sun, 21 Nov 2021 03:21:58 +0100 (CET)
From: Visuwesh <visuwesh@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Message-ID: <Mp-ICXY--3-2@HIDDEN>
In-Reply-To: <86fsrqptnp.fsf@HIDDEN>
References: <87o87dvxbp.fsf@HIDDEN> <MmsUGNG--3-2@HIDDEN>
 <874k95vw63.fsf@HIDDEN> <86y25p6yhq.fsf@HIDDEN>
 <Mobub4z--3-2@HIDDEN> <86r1bfoowu.fsf@HIDDEN>
 <Mof_1ES--3-2@HIDDEN> <8635nv9rtc.fsf@HIDDEN>
 <MoxW4HW--3-2@HIDDEN> <86fsrqptnp.fsf@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

21 Nov 2021, 00:42 by juri@HIDDEN:

Hi Juri,

>>>One problem I had with writing tests for such a feature =E2=80=94 tests =
for repeat-mode
>>>are based on =E2=80=98execute-kbd-macro=E2=80=99, but an error ends the =
keyboard macro.
>>>So probably there will be no tests for this error-signaling repeatable c=
ommands.
>>
>> I wonder if the new mechanism added to ERT by Lars could be help here?
>> (and used by the indentation tests)=C2=A0 But I suppose you still have t=
o end
>> up using keyboard macros one way or another...
>
> I don't know how buffer-based ERT fixtures could help to test repeatable
> key sequences. What I rather tried to do is to use =E2=80=98ert-simulate-=
command=E2=80=99
> (after removing =E2=80=98(cl-assert (not unread-command-events) t)=E2=80=
=99) and
> =E2=80=98ert-simulate-keys=E2=80=99 (after adding =E2=80=98(noninteractiv=
e nil)=E2=80=99 let-binding),
> to no avail.

I was thinking about grouping navigation commands that could `error'
(like in OP and the outline commands) in a repeatable keymap and making
use of Point-Char spec to test where the point ends up.
But I suppose this wouldn't get us anywhere since you still have to
"press" those keys somehow.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 20 Nov 2021 19:19:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 20 14:19:41 2021
Received: from localhost ([127.0.0.1]:43690 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1moVtl-0003ov-3D
	for submit <at> debbugs.gnu.org; Sat, 20 Nov 2021 14:19:41 -0500
Received: from relay10.mail.gandi.net ([217.70.178.230]:59205)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1moVti-0003oa-QF
 for 51390 <at> debbugs.gnu.org; Sat, 20 Nov 2021 14:19:39 -0500
Received: (Authenticated sender: juri@HIDDEN)
 by relay10.mail.gandi.net (Postfix) with ESMTPSA id 5E818240002;
 Sat, 20 Nov 2021 19:19:30 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Visuwesh <visuwesh@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
Organization: LINKOV.NET
References: <MmsHxhi--3-2@HIDDEN> <87o87dvxbp.fsf@HIDDEN>
 <MmsUGNG--3-2@HIDDEN> <874k95vw63.fsf@HIDDEN>
 <86y25p6yhq.fsf@HIDDEN> <Mobub4z--3-2@HIDDEN>
 <86r1bfoowu.fsf@HIDDEN> <Mof_1ES--3-2@HIDDEN>
 <8635nv9rtc.fsf@HIDDEN> <MoxW4HW--3-2@HIDDEN>
Date: Sat, 20 Nov 2021 21:12:46 +0200
In-Reply-To: <MoxW4HW--3-2@HIDDEN> (visuwesh@HIDDEN's message of
 "Sat, 20 Nov 2021 14:23:43 +0100 (CET)")
Message-ID: <86fsrqptnp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>>One problem I had with writing tests for such a feature — tests for repeat-mode
>>are based on ‘execute-kbd-macro’, but an error ends the keyboard macro.
>>So probably there will be no tests for this error-signaling repeatable commands.
>
> I wonder if the new mechanism added to ERT by Lars could be help here?
> (and used by the indentation tests)  But I suppose you still have to end
> up using keyboard macros one way or another...

I don't know how buffer-based ERT fixtures could help to test repeatable
key sequences.  What I rather tried to do is to use ‘ert-simulate-command’
(after removing ‘(cl-assert (not unread-command-events) t)’) and
‘ert-simulate-keys’ (after adding ‘(noninteractive nil)’ let-binding),
to no avail.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 20 Nov 2021 13:23:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 20 08:23:54 2021
Received: from localhost ([127.0.0.1]:41935 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1moQLS-0005JE-OC
	for submit <at> debbugs.gnu.org; Sat, 20 Nov 2021 08:23:54 -0500
Received: from w1.tutanota.de ([81.3.6.162]:55794)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <visuwesh@HIDDEN>) id 1moQLN-0005Ir-L6
 for 51390 <at> debbugs.gnu.org; Sat, 20 Nov 2021 08:23:53 -0500
Received: from w3.tutanota.de (unknown [192.168.1.164])
 by w1.tutanota.de (Postfix) with ESMTP id 89685FBF7E6;
 Sat, 20 Nov 2021 13:23:43 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1637414623; 
 s=s1; d=tutanota.com;
 h=From:From:To:To:Subject:Subject:Content-Description:Content-ID:Content-Type:Content-Type:Content-Transfer-Encoding:Content-Transfer-Encoding:Cc:Cc:Date:Date:In-Reply-To:In-Reply-To:MIME-Version:MIME-Version:Message-ID:Message-ID:Reply-To:References:References:Sender;
 bh=WznkqpybQ87BpGha8RNmFmuvvj2QKuIivVmsZZMFflU=;
 b=N8FGTIyM+CNoyeEGRst/SLOrUfL+vzXmFw/K5rrICieakTCl+/47uNUYtzAk87nG
 VmxTA7a71lHCk+XGqy8Cslj70q00VNhhuBaWkO20aGFkiWnncKYGVwmyKkVbrrzbouH
 ICr+2srBRryV0CJPBL657Ibytu05OFBAq94a7nyQGIU+pU/pWlhwEJ5G80ZIlYV8pNd
 gSC6puwFLP1wlY8MsgnBn7UQgB/QBMQoxjxuR4osnYHn0AyfkcGLpTRoEWB6vRJBkba
 dapY/zFfiFyUhchz8N8/NBVlV7LvhkquO6SRk+Z+h4MpdMb4TsMauCzcvvd3KJR9nmc
 0w0M0ZlZKg==
Date: Sat, 20 Nov 2021 14:23:43 +0100 (CET)
From: Visuwesh <visuwesh@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Message-ID: <MoxW4HW--3-2@HIDDEN>
In-Reply-To: <8635nv9rtc.fsf@HIDDEN>
References: <MmsHxhi--3-2@HIDDEN> <87o87dvxbp.fsf@HIDDEN>
 <MmsUGNG--3-2@HIDDEN> <874k95vw63.fsf@HIDDEN>
 <86y25p6yhq.fsf@HIDDEN> <Mobub4z--3-2@HIDDEN>
 <86r1bfoowu.fsf@HIDDEN> <Mof_1ES--3-2@HIDDEN>
 <8635nv9rtc.fsf@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

17 Nov 2021, 13:24 by juri@HIDDEN:

Hi Juri,

>Thanks, everything's clear now. And no worries =E2=80=94 a new option will=
 allow
>to not end the repeating sequence on error.

Great, thanks!

>One problem I had with writing tests for such a feature =E2=80=94 tests fo=
r repeat-mode
>are based on =E2=80=98execute-kbd-macro=E2=80=99, but an error ends the ke=
yboard macro.
>So probably there will be no tests for this error-signaling repeatable com=
mands.

I wonder if the new mechanism added to ERT by Lars could be help here?
(and used by the indentation tests)=C2=A0 But I suppose you still have to e=
nd
up using keyboard macros one way or another...





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 17 Nov 2021 08:20:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 17 03:20:36 2021
Received: from localhost ([127.0.0.1]:60036 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mnGBI-0008Rx-9B
	for submit <at> debbugs.gnu.org; Wed, 17 Nov 2021 03:20:36 -0500
Received: from relay4-d.mail.gandi.net ([217.70.183.196]:36237)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1mnGBG-0008Rh-C9
 for 51390 <at> debbugs.gnu.org; Wed, 17 Nov 2021 03:20:34 -0500
Received: (Authenticated sender: juri@HIDDEN)
 by relay4-d.mail.gandi.net (Postfix) with ESMTPSA id 0417DE0003;
 Wed, 17 Nov 2021 08:20:26 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Visuwesh <visuwesh@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
Organization: LINKOV.NET
References: <MmsHxhi--3-2@HIDDEN> <87o87dvxbp.fsf@HIDDEN>
 <MmsUGNG--3-2@HIDDEN> <874k95vw63.fsf@HIDDEN>
 <86y25p6yhq.fsf@HIDDEN> <Mobub4z--3-2@HIDDEN>
 <86r1bfoowu.fsf@HIDDEN> <Mof_1ES--3-2@HIDDEN>
Date: Wed, 17 Nov 2021 09:54:55 +0200
In-Reply-To: <Mof_1ES--3-2@HIDDEN> (visuwesh@HIDDEN's message of
 "Wed, 17 Nov 2021 02:47:49 +0100 (CET)")
Message-ID: <8635nv9rtc.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> When you do not know the structure of the outline headings beforehand,
> it can so happen that you press f/b anticipating that there's a heading
> on the same level but that might not be case.  If f/b `error's, then you
> have to press n/p to continue navigating.  This is what I meant by
> "misfiring."
>
> If repeat-mode decides to end the repeating sequence, I'd have to start
> again with C-c @ C-n.  IMO, this isn't a friendly interface.
>
>>Triggering repeat-map on error is a bug that will be fixed.
>>But it will be fixed in such a way that the error will exit
>>the repeating sequence.
>
> My point is that sometimes it is desirable to not end the sequence on
> `error'.

Thanks, everything's clear now.  And no worries — a new option will allow
to not end the repeating sequence on error.

One problem I had with writing tests for such a feature — tests for repeat-mode
are based on ‘execute-kbd-macro’, but an error ends the keyboard macro.
So probably there will be no tests for this error-signaling repeatable commands.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 17 Nov 2021 01:47:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 16 20:47:57 2021
Received: from localhost ([127.0.0.1]:59531 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mnA3J-0004OI-CZ
	for submit <at> debbugs.gnu.org; Tue, 16 Nov 2021 20:47:57 -0500
Received: from w1.tutanota.de ([81.3.6.162]:42568)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <visuwesh@HIDDEN>) id 1mnA3H-0004NJ-BQ
 for 51390 <at> debbugs.gnu.org; Tue, 16 Nov 2021 20:47:56 -0500
Received: from w3.tutanota.de (unknown [192.168.1.164])
 by w1.tutanota.de (Postfix) with ESMTP id 9670CFA0EA0;
 Wed, 17 Nov 2021 01:47:49 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1637113669; 
 s=s1; d=tutanota.com;
 h=From:From:To:To:Subject:Subject:Content-Description:Content-ID:Content-Type:Content-Type:Content-Transfer-Encoding:Content-Transfer-Encoding:Cc:Cc:Date:Date:In-Reply-To:In-Reply-To:MIME-Version:MIME-Version:Message-ID:Message-ID:Reply-To:References:References:Sender;
 bh=K7vNs8jXtRx0KfsCzEefFpuu5tW0jiEBxnnJ20haxvE=;
 b=RKTBpO0+yVAUlWm9aMHruG+CCFcQoYsCmHnf3pUSgee39iPPr3wezA3k3QHrgJUK
 /3oj25fDZqbI4rEH6aH+8UsYjA3Pk3hYMYirfMciUChob7NSR3yrZhw7brchCfD1UUy
 zFOadBj2mfHZc46hCwGV8hNRoudjPp0lk6gdSgrUPrORwL2JaC8kJDTfEke2FL+dM4n
 X2lf2VB0rXEXDP5S6Ik64+gpiYbmeRu/h/aZEFKIdgpZnnqXjkbID1PA0tiNG/wUf4c
 9oiYG1asHnBgmsZH5UtkaSi1SJVwviKCg2sx5gqciAqA9q89y8MMiL1S0kywUuW3gXa
 3wIy8zAs8A==
Date: Wed, 17 Nov 2021 02:47:49 +0100 (CET)
From: Visuwesh <visuwesh@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Message-ID: <Mof_1ES--3-2@HIDDEN>
In-Reply-To: <86r1bfoowu.fsf@HIDDEN>
References: <MmsHxhi--3-2@HIDDEN> <87o87dvxbp.fsf@HIDDEN>
 <MmsUGNG--3-2@HIDDEN> <874k95vw63.fsf@HIDDEN>
 <86y25p6yhq.fsf@HIDDEN> <Mobub4z--3-2@HIDDEN>
 <86r1bfoowu.fsf@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Juri,

17 Nov 2021, 01:48 by juri@HIDDEN:
>>I think implementing this will actually end up making certain repeat-maps
>>tedious to use.=C2=A0 One example that comes to mind is
>>`outline-navigation-repeat-map' where it is quite easy to misfire f/b
>>when you actually want n/p.=C2=A0 Starting the map again with C-c @ C-n i=
s
>>quite tedious.=C2=A0 I hope you reconsider this, or make the current
>>behaviour opt-in.
>
>Please clarify how can you misfire f/b when you intended n/p.
>What keys does your keymap contain?

From M-x describe-repeat-maps,

=E2=80=98outline-navigation-repeat-map=E2=80=99 keymap is repeatable by the=
se commands:
=E2=80=98outline-backward-same-level=E2=80=99 (f)
=E2=80=98outline-forward-same-level=E2=80=99 (b)
=E2=80=98outline-next-visible-heading=E2=80=99 (n)
=E2=80=98outline-previous-visible-heading=E2=80=99 (p)
=E2=80=98outline-up-heading=E2=80=99 (u)

When you do not know the structure of the outline headings beforehand,
it can so happen that you press f/b anticipating that there's a heading
on the same level but that might not be case.=C2=A0 If f/b `error's, then y=
ou
have to press n/p to continue navigating.=C2=A0 This is what I meant by
"misfiring."

If repeat-mode decides to end the repeating sequence, I'd have to start
again with C-c @ C-n.=C2=A0 IMO, this isn't a friendly interface.

>>Although triggering repeat-map on error is strange for the scenario in
>>OP, I hope the above convinces you regardless.=C2=A0 I only noticed the
>>behaviour on error is desirable after I started using the outline functio=
ns
>>a bit more.
>
>Triggering repeat-map on error is a bug that will be fixed.
>But it will be fixed in such a way that the error will exit
>the repeating sequence.

My point is that sometimes it is desirable to not end the sequence on
`error'.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 16 Nov 2021 20:38:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 16 15:38:10 2021
Received: from localhost ([127.0.0.1]:59317 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mn5DW-0004av-LY
	for submit <at> debbugs.gnu.org; Tue, 16 Nov 2021 15:38:10 -0500
Received: from relay5-d.mail.gandi.net ([217.70.183.197]:55279)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1mn5DV-0004aH-3h
 for 51390 <at> debbugs.gnu.org; Tue, 16 Nov 2021 15:38:10 -0500
Received: (Authenticated sender: juri@HIDDEN)
 by relay5-d.mail.gandi.net (Postfix) with ESMTPSA id EAA271C0003;
 Tue, 16 Nov 2021 20:38:01 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Visuwesh <visuwesh@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
Organization: LINKOV.NET
References: <MmsHxhi--3-2@HIDDEN> <87o87dvxbp.fsf@HIDDEN>
 <MmsUGNG--3-2@HIDDEN> <874k95vw63.fsf@HIDDEN>
 <86y25p6yhq.fsf@HIDDEN> <Mobub4z--3-2@HIDDEN>
Date: Tue, 16 Nov 2021 22:18:17 +0200
In-Reply-To: <Mobub4z--3-2@HIDDEN> (visuwesh@HIDDEN's message of
 "Tue, 16 Nov 2021 09:43:36 +0100 (CET)")
Message-ID: <86r1bfoowu.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> I think implementing this will actually end up making certain repeat-maps
> tedious to use. One example that comes to mind is
> `outline-navigation-repeat-map' where it is quite easy to misfire f/b
> when you actually want n/p. Starting the map again with C-c @ C-n is
> quite tedious. I hope you reconsider this, or make the current
> behaviour opt-in.

Please clarify how can you misfire f/b when you intended n/p.
What keys does your keymap contain?

> Although triggering repeat-map on error is strange for the scenario in
> OP, I hope the above convinces you regardless. I only noticed the
> behaviour on error is desirable after I started using the outline functions
> a bit more.

Triggering repeat-map on error is a bug that will be fixed.
But it will be fixed in such a way that the error will exit
the repeating sequence.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 16 Nov 2021 08:43:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 16 03:43:44 2021
Received: from localhost ([127.0.0.1]:57072 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mmu48-0000j1-Mb
	for submit <at> debbugs.gnu.org; Tue, 16 Nov 2021 03:43:44 -0500
Received: from w1.tutanota.de ([81.3.6.162]:56136)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <visuwesh@HIDDEN>) id 1mmu47-0000il-49
 for 51390 <at> debbugs.gnu.org; Tue, 16 Nov 2021 03:43:43 -0500
Received: from w3.tutanota.de (unknown [192.168.1.164])
 by w1.tutanota.de (Postfix) with ESMTP id 1B095FBF837;
 Tue, 16 Nov 2021 08:43:37 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1637052216; 
 s=s1; d=tutanota.com;
 h=From:From:To:To:Subject:Subject:Content-Description:Content-ID:Content-Type:Content-Type:Content-Transfer-Encoding:Content-Transfer-Encoding:Cc:Cc:Date:Date:In-Reply-To:In-Reply-To:MIME-Version:MIME-Version:Message-ID:Message-ID:Reply-To:References:References:Sender;
 bh=NhsnQx9n9+RfkGZRLzOGy4IeZlQTnHvIRIx9uCc924E=;
 b=jJlVwlqXUc5a/eoMPQLpJONi1nNECixeR6iGE+L3jKDj8FFCtN9Rw4JlU4CZeyhA
 6mfY+ftwpKxoS830uBX21r2VvLYMNCkOUTeS6Q7aZDggZ4lBa8rKkKwXqeL/mrS0lQi
 D9XdVLkrKpM4qyYLyHaK14YtZ2qZAeckxDQv4d048y87Q9N+z5kvziA6qY9T7R2j1I1
 pFsE0X0TpfVM99owj9rHxYIJVRxPVUXoHv4zNXff1435z/k46ip3Eo14UeQOYMLQpdk
 D5rh0eLyxQLxV7bNLLUOABNdkyRFjaQiShfE1EQI7Zi5VgLKT11j/UUVbn/GYSAdMc0
 aRKwVJA4Uw==
Date: Tue, 16 Nov 2021 09:43:36 +0100 (CET)
From: Visuwesh <visuwesh@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Message-ID: <Mobub4z--3-2@HIDDEN>
In-Reply-To: <86y25p6yhq.fsf@HIDDEN>
References: <MmsHxhi--3-2@HIDDEN> <87o87dvxbp.fsf@HIDDEN>
 <MmsUGNG--3-2@HIDDEN> <874k95vw63.fsf@HIDDEN>
 <86y25p6yhq.fsf@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <51390 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

16 Nov 2021, 00:24 by juri@HIDDEN:

Hi Juri,
> Or maybe this is not a bug: since an error stops executing a keyboard mac=
ro,
> it makes sense to stop a repeating sequence on error as well
> (this logic will be applied after fixing the reported bug).
>

I think implementing this will actually end up making certain repeat-maps
tedious to use.=C2=A0 One example that comes to mind is
`outline-navigation-repeat-map' where it is quite easy to misfire f/b
when you actually want n/p.=C2=A0 Starting the map again with C-c @ C-n is
quite tedious.=C2=A0 I hope you reconsider this, or make the current
behaviour opt-in.

Although triggering repeat-map on error is strange for the scenario in
OP, I hope the above convinces you regardless.=C2=A0 I only noticed the
behaviour on error is desirable after I started using the outline functions
a bit more.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 15 Nov 2021 18:56:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 15 13:56:24 2021
Received: from localhost ([127.0.0.1]:56163 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mmh9U-0005vC-03
	for submit <at> debbugs.gnu.org; Mon, 15 Nov 2021 13:56:24 -0500
Received: from relay5-d.mail.gandi.net ([217.70.183.197]:50289)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1mmh9S-0005ur-1v
 for 51390 <at> debbugs.gnu.org; Mon, 15 Nov 2021 13:56:22 -0500
Received: (Authenticated sender: juri@HIDDEN)
 by relay5-d.mail.gandi.net (Postfix) with ESMTPSA id 3ACE81C0003;
 Mon, 15 Nov 2021 18:56:13 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Visuwesh <visuwesh@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
Organization: LINKOV.NET
References: <MmsHxhi--3-2@HIDDEN> <87o87dvxbp.fsf@HIDDEN>
 <MmsUGNG--3-2@HIDDEN> <874k95vw63.fsf@HIDDEN>
Date: Mon, 15 Nov 2021 20:54:25 +0200
In-Reply-To: <874k95vw63.fsf@HIDDEN> (Juri Linkov's message of "Mon, 
 25 Oct 2021 20:41:56 +0300")
Message-ID: <86y25p6yhq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>>> This is because currently only the last character of the initial
>>> key sequence is allowed to be repeated.  The initial key was "C-n"
>>> and the repeat key is "n" - it's not the same key.  This condition
>>> was added to repeat only such key sequences 'C-x u  u u u ...',
>>> but not 'C-/  u u u u ...'.
>>
>> That explains why I can't repeat C-n, but what makes repeat-mode
>> repeat C-n when at the first line?  That really perplexes me and I'm
>> curious to know the reason.
>
> It seems you found a bug.  When typing C-p at the beginning of the
> buffer it signals an error "Beginning of buffer" (this is correct).
>
> But in this case '(this-command-keys-vector)' used by repeat-mode
> returns [].  This is an unexpected value.

Or maybe this is not a bug: since an error stops executing a keyboard macro,
it makes sense to stop a repeating sequence on error as well
(this logic will be applied after fixing the reported bug).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 25 Oct 2021 17:43:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 25 13:43:08 2021
Received: from localhost ([127.0.0.1]:44211 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mf404-0003gB-FT
	for submit <at> debbugs.gnu.org; Mon, 25 Oct 2021 13:43:08 -0400
Received: from relay7-d.mail.gandi.net ([217.70.183.200]:48279)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1mf401-0003ff-MW
 for 51390 <at> debbugs.gnu.org; Mon, 25 Oct 2021 13:43:06 -0400
Received: (Authenticated sender: juri@HIDDEN)
 by relay7-d.mail.gandi.net (Postfix) with ESMTPSA id 6CCA320005;
 Mon, 25 Oct 2021 17:42:57 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Visuwesh <visuwesh@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
Organization: LINKOV.NET
References: <MmsHxhi--3-2@HIDDEN> <87o87dvxbp.fsf@HIDDEN>
 <MmsUGNG--3-2@HIDDEN>
Date: Mon, 25 Oct 2021 20:41:56 +0300
In-Reply-To: <MmsUGNG--3-2@HIDDEN> (visuwesh@HIDDEN's message of
 "Mon, 25 Oct 2021 19:26:19 +0200 (CEST)")
Message-ID: <874k95vw63.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> This is because currently only the last character of the initial
>> key sequence is allowed to be repeated.  The initial key was "C-n"
>> and the repeat key is "n" - it's not the same key.  This condition
>> was added to repeat only such key sequences 'C-x u  u u u ...',
>> but not 'C-/  u u u u ...'.
>
> That explains why I can't repeat C-n, but what makes repeat-mode
> repeat C-n when at the first line?  That really perplexes me and I'm
> curious to know the reason.

It seems you found a bug.  When typing C-p at the beginning of the
buffer it signals an error "Beginning of buffer" (this is correct).

But in this case '(this-command-keys-vector)' used by repeat-mode
returns [].  This is an unexpected value.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 25 Oct 2021 17:26:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 25 13:26:28 2021
Received: from localhost ([127.0.0.1]:44189 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mf3jv-0003Gx-Qw
	for submit <at> debbugs.gnu.org; Mon, 25 Oct 2021 13:26:28 -0400
Received: from w1.tutanota.de ([81.3.6.162]:33052)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <visuwesh@HIDDEN>) id 1mf3jt-0003Gk-Mc
 for 51390 <at> debbugs.gnu.org; Mon, 25 Oct 2021 13:26:26 -0400
Received: from w3.tutanota.de (unknown [192.168.1.164])
 by w1.tutanota.de (Postfix) with ESMTP id A2839FBF656;
 Mon, 25 Oct 2021 17:26:19 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1635182779; 
 s=s1; d=tutanota.com;
 h=From:From:To:To:Subject:Subject:Content-Description:Content-ID:Content-Type:Content-Type:Content-Transfer-Encoding:Content-Transfer-Encoding:Cc:Cc:Date:Date:In-Reply-To:In-Reply-To:MIME-Version:MIME-Version:Message-ID:Message-ID:Reply-To:References:References:Sender;
 bh=SZnf+uNd5N7SG5lgYD0pRPTZfvra8Clx/vt1PPM8oCk=;
 b=JM81dd7ZwiCc83rkwng7PuogImLRxDiCWZVp8xABB+GUWaibzRpcFLZdBZMTypyC
 FFwXmCCXbJ9uMfXmh1yp71711ud/XZDHI7w7kaajjDsW3PRzYG/Pe43QWjB9LeOfEbg
 t60SJbfwMrDEnVJlvUT8DtTbb8pYA6M8GTRrytF/BFFi72NvkH2M0u6VIRXbj7m/uEX
 65C1rm57ah1SSI/3+UpQdqfqI6mMkMqLo3DcEjGl+I1mC7h3pVIcp3QRuhWoYmnLUf5
 Ht/bIrN2ZWsKhCz5DGyktORxtuK/UITbwtlhN8Fl3+1ItroK5MoYdeN9Y1nKKTqm4Xj
 TjQVqd1ugA==
Date: Mon, 25 Oct 2021 19:26:19 +0200 (CEST)
From: Visuwesh <visuwesh@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Message-ID: <MmsUGNG--3-2@HIDDEN>
In-Reply-To: <87o87dvxbp.fsf@HIDDEN>
References: <MmsHxhi--3-2@HIDDEN> <87o87dvxbp.fsf@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

25 Oct 2021, 22:46 by juri@HIDDEN:

Hello Juri,

>> [...]
> This is because currently only the last character of the initial
> key sequence is allowed to be repeated.  The initial key was "C-n"
> and the repeat key is "n" - it's not the same key.  This condition
> was added to repeat only such key sequences 'C-x u  u u u ...',
> but not 'C-/  u u u u ...'.=20
>

That explains why I can't repeat C-n, but what makes repeat-mode
repeat C-n when at the first line?=C2=A0 That really perplexes me and I'm
curious to know the reason.=C2=A0=C2=A0


>  Now addition of a new option is underway.
> It will allow customization of such preference.
>

Thank you for looking into this!




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at 51390 <at> debbugs.gnu.org:


Received: (at 51390) by debbugs.gnu.org; 25 Oct 2021 17:18:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 25 13:18:41 2021
Received: from localhost ([127.0.0.1]:44177 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mf3cP-00034z-N4
	for submit <at> debbugs.gnu.org; Mon, 25 Oct 2021 13:18:41 -0400
Received: from relay10.mail.gandi.net ([217.70.178.230]:56123)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1mf3cO-00034e-4c
 for 51390 <at> debbugs.gnu.org; Mon, 25 Oct 2021 13:18:40 -0400
Received: (Authenticated sender: juri@HIDDEN)
 by relay10.mail.gandi.net (Postfix) with ESMTPSA id 760E8240007;
 Mon, 25 Oct 2021 17:18:32 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Visuwesh via "Bug reports for GNU Emacs, the Swiss army knife of text
 editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
Organization: LINKOV.NET
References: <MmsHxhi--3-2@HIDDEN>
Date: Mon, 25 Oct 2021 20:16:58 +0300
In-Reply-To: <MmsHxhi--3-2@HIDDEN> (Visuwesh via's message of "Mon, 25
 Oct 2021 18:32:33 +0200 (CEST)")
Message-ID: <87o87dvxbp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 51390
Cc: 51390 <at> debbugs.gnu.org, Visuwesh <visuwesh@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

> I'm trying to make next/previous-line repeatable by using the follow
> code snippet,
>
>         (defvar teest
>           (let ((map (make-sparse-keymap)))
>             (define-key map "n" #'next-line)
>             (define-key map "p" #'previous-line)
>             map))
>
> To reproduce the issue,
>
> 1. emacs -Q
> 2. Evaluate the expressions in this message.  Turn on repeat-mode.
> 3. Switch to the *scratch* buffer and press M-<.
> 4. Type C-n.  Notice that it does not trigger the repeat map.
> 5. Type C-p twice.  The repeat map gets triggered in the second keypress
> i.e., when the point is at the first line.

This is because currently only the last character of the initial
key sequence is allowed to be repeated.  The initial key was "C-n"
and the repeat key is "n" - it's not the same key.  This condition
was added to repeat only such key sequences 'C-x u  u u u ...',
but not 'C-/  u u u u ...'.  Now addition of a new option is underway.
It will allow customization of such preference.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 25 Oct 2021 17:18:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 25 13:18:45 2021
Received: from localhost ([127.0.0.1]:44179 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mf3cS-00035A-Ui
	for submit <at> debbugs.gnu.org; Mon, 25 Oct 2021 13:18:45 -0400
Received: from lists.gnu.org ([209.51.188.17]:51568)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1mf3cO-00034n-8i
 for submit <at> debbugs.gnu.org; Mon, 25 Oct 2021 13:18:41 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:44308)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <juri@HIDDEN>) id 1mf3cO-0001x2-0v
 for bug-gnu-emacs@HIDDEN; Mon, 25 Oct 2021 13:18:40 -0400
Received: from relay10.mail.gandi.net ([217.70.178.230]:58725)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <juri@HIDDEN>) id 1mf3cM-0006JF-0U
 for bug-gnu-emacs@HIDDEN; Mon, 25 Oct 2021 13:18:39 -0400
Received: (Authenticated sender: juri@HIDDEN)
 by relay10.mail.gandi.net (Postfix) with ESMTPSA id 760E8240007;
 Mon, 25 Oct 2021 17:18:32 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Visuwesh via "Bug reports for GNU Emacs, the Swiss army knife of text
 editors" <bug-gnu-emacs@HIDDEN>
Subject: Re: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in
 global-map(?)
Organization: LINKOV.NET
References: <MmsHxhi--3-2@HIDDEN>
Date: Mon, 25 Oct 2021 20:16:58 +0300
In-Reply-To: <MmsHxhi--3-2@HIDDEN> (Visuwesh via's message of "Mon, 25
 Oct 2021 18:32:33 +0200 (CEST)")
Message-ID: <87o87dvxbp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
Received-SPF: pass client-ip=217.70.178.230; envelope-from=juri@HIDDEN;
 helo=relay10.mail.gandi.net
X-Spam_score_int: -25
X-Spam_score: -2.6
X-Spam_bar: --
X-Spam_report: (-2.6 / 5.0 requ) BAYES_00=-1.9, RCVD_IN_DNSWL_LOW=-0.7,
 RCVD_IN_MSPIKE_H2=-0.001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.6 (-)
X-Debbugs-Envelope-To: submit
Cc: 51390 <at> debbugs.gnu.org, Visuwesh <visuwesh@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.6 (--)

> I'm trying to make next/previous-line repeatable by using the follow
> code snippet,
>
>         (defvar teest
>           (let ((map (make-sparse-keymap)))
>             (define-key map "n" #'next-line)
>             (define-key map "p" #'previous-line)
>             map))
>
> To reproduce the issue,
>
> 1. emacs -Q
> 2. Evaluate the expressions in this message.  Turn on repeat-mode.
> 3. Switch to the *scratch* buffer and press M-<.
> 4. Type C-n.  Notice that it does not trigger the repeat map.
> 5. Type C-p twice.  The repeat map gets triggered in the second keypress
> i.e., when the point is at the first line.

This is because currently only the last character of the initial
key sequence is allowed to be repeated.  The initial key was "C-n"
and the repeat key is "n" - it's not the same key.  This condition
was added to repeat only such key sequences 'C-x u  u u u ...',
but not 'C-/  u u u u ...'.  Now addition of a new option is underway.
It will allow customization of such preference.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 25 Oct 2021 16:32:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 25 12:32:42 2021
Received: from localhost ([127.0.0.1]:44123 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mf2tu-0001v7-68
	for submit <at> debbugs.gnu.org; Mon, 25 Oct 2021 12:32:42 -0400
Received: from lists.gnu.org ([209.51.188.17]:36342)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <visuwesh@HIDDEN>) id 1mf2ts-0001v0-Lt
 for submit <at> debbugs.gnu.org; Mon, 25 Oct 2021 12:32:41 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:34108)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <visuwesh@HIDDEN>)
 id 1mf2ts-0004x9-Fi
 for bug-gnu-emacs@HIDDEN; Mon, 25 Oct 2021 12:32:40 -0400
Received: from w1.tutanota.de ([81.3.6.162]:41934)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <visuwesh@HIDDEN>)
 id 1mf2tq-0005ME-2K
 for bug-gnu-emacs@HIDDEN; Mon, 25 Oct 2021 12:32:40 -0400
Received: from w3.tutanota.de (unknown [192.168.1.164])
 by w1.tutanota.de (Postfix) with ESMTP id 89342FBF58B
 for <bug-gnu-emacs@HIDDEN>; Mon, 25 Oct 2021 16:32:33 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1635179553; 
 s=s1; d=tutanota.com;
 h=From:From:To:To:Subject:Subject:Content-Description:Content-ID:Content-Type:Content-Type:Content-Transfer-Encoding:Content-Transfer-Encoding:Cc:Date:Date:In-Reply-To:MIME-Version:MIME-Version:Message-ID:Message-ID:Reply-To:References:Sender;
 bh=4scKphGstagWi8GbN5f6wJsSWOl2Tv4uj7TuMn9vlaA=;
 b=wrDkGeR0+vCM8CE0/WX2tkH+wBuXJCL/Mra1v+EEUfKTUkJC6lgXkkL9IrZCi+GR
 QrS7Z4NByhUjxKIq/tLPMRGeQCRiVJ2Yw8HoHQnUmi4TCTFN5WmEylQJSRGd+X3R+KX
 oiJg/4sCsMJPUmb/7aiY3Q1eXG+0Qm25FA+tIB00QSyoB+ZgwrT9QheLIJuLNscxkQm
 saTm7HYkeC6FTXri/ILFBCzGZXdhldbkkk8PB79MexzJ2iYulWCtgkW9EXNghdRu0wV
 pON2/6aPrPehmKzXDUKlCIsaNvzOlZs4/99BRCNreRixo5GGfKdszzS47MdgClfmUS1
 oVkBTSI4JQ==
Date: Mon, 25 Oct 2021 18:32:33 +0200 (CEST)
From: Visuwesh <visuwesh@HIDDEN>
To: Bug Gnu Emacs <bug-gnu-emacs@HIDDEN>
Message-ID: <MmsHxhi--3-2@HIDDEN>
Subject: 29.0.50; repeat-mode: Fails to repeat keys in global-map(?)
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
Received-SPF: pass client-ip=81.3.6.162; envelope-from=visuwesh@HIDDEN;
 helo=w1.tutanota.de
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 RCVD_IN_MSPIKE_H3=0.001, RCVD_IN_MSPIKE_WL=0.001, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Hello,

I'm trying to make next/previous-line repeatable by using the follow
code snippet,

=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (defvar teest
=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (let ((map (make-spa=
rse-keymap)))
=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (define-=
key map "n" #'next-line)
=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (define-=
key map "p" #'previous-line)
=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 map))

=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (put 'next-line 'repeat-map 'tee=
st)
=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (put 'previous-line 'repeat-map =
'teest)

However, next-line triggers the repeat map only when it is run in the
last line of the buffer, and similarly previous-line triggers the repeat
map only when it is run in the first line of the buffer.

A similar behaviour is observed when replacing next-line and
previous-line with forward-char at BOB and backward-char at EOB
respectively.=C2=A0 If I make move-end/beginning-of-line repeatable instead=
,
 the repeat map does not get triggered at all (regardless of where the=20
point is).

To reproduce the issue,

1. emacs -Q
2. Evaluate the expressions in this message.=C2=A0 Turn on repeat-mode.
3. Switch to the *scratch* buffer and press M-<.
4. Type C-n.=C2=A0 Notice that it does not trigger the repeat map.
5. Type C-p twice.=C2=A0 The repeat map gets triggered in the second keypre=
ss
i.e., when the point is at the first line.

I can reproduce this issue in the master branch and in an Emacs 28 build
with emacs-repository-version fc8df2561b8e37089463d0d4d008d73e23cb2dc5.

Regards.

In GNU Emacs 29.0.50 (build 1, x86_64-pc-linux-gnu, GTK+ Version 3.24.27, c=
airo version 1.16.0)
Repository revision: 709e1e59f0f4db24580566f5ca661e730afbf9a2
Repository branch: master
Windowing system distributor 'The X.Org Foundation', version 11.0.12012000
System Description: NixOS 21.11 (Porcupine)

Configured using:
'configure
--prefix=3D/nix/store/w1fmhydqpvjl9lz9frqsc8203d0nqd76-emacs-git-20211025.0
--disable-build-details --with-modules --with-x-toolkit=3Dgtk3 --with-xft
--with-cairo'

Configured features:
CAIRO DBUS FREETYPE GIF GLIB GMP GNUTLS GSETTINGS HARFBUZZ JPEG JSON
LIBOTF LIBSELINUX LIBSYSTEMD LIBXML2 M17N_FLT MODULES NOTIFY INOTIFY
PDUMPER PNG RSVG SECCOMP SOUND THREADS TIFF TOOLKIT_SCROLL_BARS X11 XDBE
XIM XPM GTK3 ZLIB

Important settings:
=C2=A0 value of $EMACSLOADPATH:
=C2=A0 value of $EMACSNATIVELOADPATH: /nix/store/llq9dy2f8zmf697jwrnly37g66=
pwwq1y-emacs-packages-deps/share/emacs/native-lisp::
=C2=A0 value of $LANG: en_GB.UTF-8
=C2=A0 locale-coding-system: utf-8-unix

Major mode: Lisp Interaction

Minor modes in effect:
=C2=A0 repeat-mode: t
=C2=A0 tooltip-mode: t
=C2=A0 global-eldoc-mode: t
=C2=A0 eldoc-mode: t
=C2=A0 show-paren-mode: t
=C2=A0 electric-indent-mode: t
=C2=A0 mouse-wheel-mode: t
=C2=A0 tool-bar-mode: t
=C2=A0 menu-bar-mode: t
=C2=A0 file-name-shadow-mode: t
=C2=A0 global-font-lock-mode: t
=C2=A0 font-lock-mode: t
=C2=A0 blink-cursor-mode: t
=C2=A0 auto-composition-mode: t
=C2=A0 auto-encryption-mode: t
=C2=A0 auto-compression-mode: t
=C2=A0 line-number-mode: t
=C2=A0 indent-tabs-mode: t
=C2=A0 transient-mark-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message rmc puny dired dired-loaddefs
rfc822 mml mml-sec epa derived epg rfc6068 epg-config gnus-util rmail
rmail-loaddefs auth-source cl-seq eieio eieio-core cl-macs
eieio-loaddefs password-cache json map text-property-search mm-decode
mm-bodies mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader
sendmail rfc2047 rfc2045 ietf-drums mm-util mail-prsvr mail-utils edebug
backtrace pulse color thingatpt xref project ring jka-compr find-func
cl-print dabbrev kmacro facemenu two-column time-date cl-extra seq gv
subr-x byte-opt bytecomp byte-compile cconv help-fns radix-tree
cus-start cus-load repeat misearch multi-isearch help-mode cl-loaddefs
cl-lib iso-transl tooltip eldoc paren electric uniquify ediff-hook
vc-hooks lisp-float-type elisp-mode mwheel term/x-win x-win
term/common-win x-dnd tool-bar dnd fontset image regexp-opt fringe
tabulated-list replace newcomment text-mode lisp-mode prog-mode register
page tab-bar menu-bar rfn-eshadow isearch easymenu timer select
scroll-bar mouse jit-lock font-lock syntax font-core term/tty-colors
frame minibuffer cl-generic cham georgian utf-8-lang misc-lang
vietnamese tibetan thai tai-viet lao korean japanese eucjp-ms cp51932
hebrew greek romanian slovak czech european ethiopic indian cyrillic
chinese composite emoji-zwj charscript charprop case-table epa-hook
jka-cmpr-hook help simple abbrev obarray cl-preloaded nadvice button
loaddefs faces cus-face macroexp files window text-properties overlay
sha1 md5 base64 format env code-pages mule custom widget
hashtable-print-readable backquote threads dbusbind inotify
dynamic-setting system-font-setting font-render-setting cairo
move-toolbar gtk x-toolkit x multi-tty make-network-process emacs)

Memory information:
((conses 16 106524 8571)
(symbols 48 9251 1)
(strings 32 25944 1615)
(string-bytes 1 863874)
(vectors 16 20434)
(vector-slots 8 465587 10211)
(floats 8 124 87)
(intervals 56 716 1127)
(buffers 992 14))





Acknowledgement sent to Visuwesh <visuwesh@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#51390; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 30 Nov 2021 19:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.